/*************************************************************************/
/*************************************************************************/
/*                                                                       */
/*  File Name : tSet.h                                                   */
/*                                                                       */
/*       Date : August 22, 1998                                          */
/* Updated at : August 22, 1998                                          */
/*                                                                       */
/*     Author : H. Timucin OZDEMIR                                       */
/*                                                                       */
/*************************************************************************/
/**
    SortedSet keeps items in decreasing order occording to the provided
    rank values.
**/
/*************************************************************************/

#ifndef _SORTEDSET_H
#define _SORTEDSET_H

#include <iostream.h>
#include "tSet.h"

template<class T1, class T2>
class SortedSet
{  

  protected:

     T1*      mySet;
     T2*      values;
     int      index;
     float    gRate;
     float    sRate;
     unsigned currentCapacity;
     unsigned capacity;

     void adjustTo(unsigned _nws);
     void adjustTo2(unsigned nws);
     void dispose();
     void copyFrom(const SortedSet<T1,T2>& RHS);
     void defineMe(unsigned _initialCapacity, float _gRate, float _sRate=0.5);

   public:

     SortedSet();
     SortedSet(unsigned _initialCapacity);
     SortedSet(unsigned _initialCapacity, float _gRate, float _sRate=0.5);

     SortedSet(const SortedSet<T1,T2>& RHS);

     ~SortedSet();

     void addElement(T1 ele, T2 fx);

     void removeAt(int indx);

     getAt(int indx, T1& rturn) const;
     isExistValue(T1);

     getIndex();
     getSize() const { return index; } ;

     inline tSet<T1> getOnlyValues() 
     { 
       tSet<T1> ret(index); 
       for(int i=0;i<index;i++) ret.addElement(mySet[i]);
       return ret; 
     };

     void clearAll() { index=0; } ;

     operator==(const SortedSet<T1,T2>&);
     SortedSet<T1,T2> operator=(const SortedSet<T1,T2>& RHS) ;

     void printMe(ostream&) const;

     friend ostream& operator<<(ostream& os,const SortedSet<T1,T2>& RHS)
     { RHS.printMe(os); return os; };

};//

#endif
